Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_event.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_event.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_event.cpp	(revision 97)
@@ -25,27 +25,66 @@
     for (uint32_t i=0; i<_param->_nb_context; ++i)
       {
-        Taddress_t address = PORT_READ(in_EVENT_CONTEXT_STATE_ADDRESS [i]);
+        Taddress_t    address = PORT_READ(in_EVENT_CONTEXT_STATE_ADDRESS [i]);
         PORT_WRITE(out_EVENT_ADDRESS             [i],address);
         PORT_WRITE(out_EVENT_IFETCH_UNIT_ADDRESS [i],address);
 
-        Taddress_t address_next = PORT_READ(in_EVENT_CONTEXT_STATE_ADDRESS_NEXT [i]);
+        Taddress_t    address_next = PORT_READ(in_EVENT_CONTEXT_STATE_ADDRESS_NEXT [i]);
         PORT_WRITE(out_EVENT_ADDRESS_NEXT             [i],address_next);
         PORT_WRITE(out_EVENT_IFETCH_UNIT_ADDRESS_NEXT [i],address_next);
 
-        Tcontrol_t address_next_val = PORT_READ(in_EVENT_CONTEXT_STATE_ADDRESS_NEXT_VAL [i]);
+        Tcontrol_t    address_next_val = PORT_READ(in_EVENT_CONTEXT_STATE_ADDRESS_NEXT_VAL [i]);
         PORT_WRITE(out_EVENT_ADDRESS_NEXT_VAL             [i],address_next_val);
         PORT_WRITE(out_EVENT_IFETCH_UNIT_ADDRESS_NEXT_VAL [i],address_next_val);
 
-        Tcontrol_t is_ds_take = PORT_READ(in_EVENT_CONTEXT_STATE_IS_DS_TAKE [i]);
+        Tcontrol_t    is_ds_take = PORT_READ(in_EVENT_CONTEXT_STATE_IS_DS_TAKE [i]);
         PORT_WRITE(out_EVENT_IS_DS_TAKE             [i],is_ds_take);
         PORT_WRITE(out_EVENT_IFETCH_UNIT_IS_DS_TAKE [i],is_ds_take);
 
-        Tcontrol_t val = PORT_READ(in_EVENT_CONTEXT_STATE_VAL [i]);
-        PORT_WRITE(out_EVENT_VAL             [i],val);
-        PORT_WRITE(out_EVENT_IFETCH_UNIT_VAL [i],val);
+        Tevent_type_t event_type = PORT_READ(in_EVENT_CONTEXT_STATE_TYPE [i]);
+        PORT_WRITE(out_EVENT_PREDICTION_UNIT_TYPE [i],event_type);
+        
+        if (_param->_have_port_depth)
+          {
+        Tdepth_t      depth = PORT_READ(in_EVENT_CONTEXT_STATE_DEPTH [i]);
+        PORT_WRITE(out_EVENT_PREDICTION_UNIT_DEPTH [i],depth);
+          }
+        
 
-        Tcontrol_t ack = (PORT_READ(in_EVENT_ACK             [i]) and
-                          PORT_READ(in_EVENT_IFETCH_UNIT_ACK [i]));
-        PORT_WRITE(out_EVENT_CONTEXT_STATE_ACK [i],ack);
+        Tcontrol_t ack                 = PORT_READ(in_EVENT_ACK                 [i]);
+        Tcontrol_t ifetch_unit_ack     = PORT_READ(in_EVENT_IFETCH_UNIT_ACK     [i]);
+        Tcontrol_t prediction_unit_ack = PORT_READ(in_EVENT_PREDICTION_UNIT_ACK [i]);
+        Tcontrol_t context_state_val   = PORT_READ(in_EVENT_CONTEXT_STATE_VAL   [i]);
+
+        Tcontrol_t val                 = (//ack                 and
+                                            ifetch_unit_ack     and
+                                            prediction_unit_ack and
+                                            context_state_val   
+                                          );
+        Tcontrol_t ifetch_unit_val     = (  ack                 and
+                                          //ifetch_unit_ack     and
+                                            prediction_unit_ack and
+                                            context_state_val   
+                                            );
+        Tcontrol_t prediction_unit_val = (  ack                 and
+                                            ifetch_unit_ack     and
+                                          //prediction_unit_ack and
+                                            context_state_val   
+                                            );
+        Tcontrol_t context_state_ack   = (  ack                 and
+                                            ifetch_unit_ack     and
+                                            prediction_unit_ack // and
+                                          //context_state_val   
+                                            );
+
+        log_printf(TRACE,Front_end_Glue,FUNCTION,"  * val                 %d, ack                 %d",val                ,ack                );
+        log_printf(TRACE,Front_end_Glue,FUNCTION,"  * ifetch_unit_val     %d, ifetch_unit_ack     %d",ifetch_unit_val    ,ifetch_unit_ack    );
+        log_printf(TRACE,Front_end_Glue,FUNCTION,"  * prediction_unit_val %d, prediction_unit_ack %d",prediction_unit_val,prediction_unit_ack);
+        log_printf(TRACE,Front_end_Glue,FUNCTION,"  * context_state_val   %d, context_state_ack   %d",context_state_val  ,context_state_ack  );
+
+
+        PORT_WRITE(out_EVENT_VAL                 [i], val                );
+        PORT_WRITE(out_EVENT_IFETCH_UNIT_VAL     [i], ifetch_unit_val    );
+        PORT_WRITE(out_EVENT_PREDICTION_UNIT_VAL [i], prediction_unit_val);
+        PORT_WRITE(out_EVENT_CONTEXT_STATE_ACK   [i], context_state_ack  );
 
 #ifdef DEBUG
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/test.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/test.cpp	(revision 97)
@@ -94,7 +94,8 @@
   ALLOC1_SC_SIGNAL(out_BRANCH_EVENT_ADDRESS_DEST          ,"out_BRANCH_EVENT_ADDRESS_DEST          ",Taddress_t         ,_param->_nb_context);
 												                         
-  ALLOC1_SC_SIGNAL( in_EVENT_STATE                    ," in_EVENT_STATE                    ",Tevent_state_t     ,_param->_nb_context);
-  ALLOC1_SC_SIGNAL( in_EVENT_TYPE                     ," in_EVENT_TYPE                     ",Tevent_type_t      ,_param->_nb_context);
-  ALLOC1_SC_SIGNAL( in_EVENT_DEPTH                    ," in_EVENT_DEPTH                    ",Tdepth_t           ,_param->_nb_context);
+  ALLOC1_SC_SIGNAL( in_EVENT_VAL                          ," in_EVENT_VAL                          ",Tcontrol_t         ,_param->_nb_context);
+  ALLOC1_SC_SIGNAL(out_EVENT_ACK                          ,"out_EVENT_ACK                          ",Tcontrol_t         ,_param->_nb_context);
+  ALLOC1_SC_SIGNAL( in_EVENT_TYPE                         ," in_EVENT_TYPE                         ",Tevent_type_t      ,_param->_nb_context);
+  ALLOC1_SC_SIGNAL( in_EVENT_DEPTH                        ," in_EVENT_DEPTH                        ",Tdepth_t           ,_param->_nb_context);
 
   ALLOC1_SC_SIGNAL(out_DEPTH_CURRENT                      ,"out_DEPTH_CURRENT                      ",Tdepth_t           ,_param->_nb_context);
@@ -160,5 +161,6 @@
   INSTANCE1_SC_SIGNAL(_Prediction_unit,out_BRANCH_EVENT_ADDRESS_DEST          ,_param->_nb_context);
 
-  INSTANCE1_SC_SIGNAL(_Prediction_unit, in_EVENT_STATE                        ,_param->_nb_context);
+  INSTANCE1_SC_SIGNAL(_Prediction_unit, in_EVENT_VAL                          ,_param->_nb_context);
+  INSTANCE1_SC_SIGNAL(_Prediction_unit,out_EVENT_ACK                          ,_param->_nb_context);
   INSTANCE1_SC_SIGNAL(_Prediction_unit, in_EVENT_TYPE                         ,_param->_nb_context);
   if (_param->_have_port_depth)
@@ -364,5 +366,6 @@
   DELETE1_SC_SIGNAL(out_BRANCH_EVENT_ADDRESS_DEST     ,_param->_nb_context);
 
-  DELETE1_SC_SIGNAL( in_EVENT_STATE                    ,_param->_nb_context);
+  DELETE1_SC_SIGNAL( in_EVENT_VAL                      ,_param->_nb_context);
+  DELETE1_SC_SIGNAL(out_EVENT_ACK                      ,_param->_nb_context);
   DELETE1_SC_SIGNAL( in_EVENT_TYPE                     ,_param->_nb_context);
   DELETE1_SC_SIGNAL( in_EVENT_DEPTH                    ,_param->_nb_context);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/test.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/test.cpp	(revision 97)
@@ -42,5 +42,5 @@
 
 #ifdef STATISTICS
-  morpheo::behavioural::Parameters_Statistics * _parameters_statistics = new morpheo::behavioural::Parameters_Statistics (5,50);
+  morpheo::behavioural::Parameters_Statistics * _parameters_statistics = new morpheo::behavioural::Parameters_Statistics (5,CYCLE_MAX);
 #endif
 
@@ -137,5 +137,6 @@
   ALLOC1_SC_SIGNAL(out_UPDATE_RAS_PREDICTION_IFETCH   ,"out_UPDATE_RAS_PREDICTION_IFETCH   ",Tcontrol_t         ,_param->_nb_inst_update);
 
-  ALLOC1_SC_SIGNAL( in_EVENT_STATE                    ," in_EVENT_STATE                    ",Tevent_state_t     ,_param->_nb_context);
+  ALLOC1_SC_SIGNAL( in_EVENT_VAL                      ," in_EVENT_VAL                      ",Tcontrol_t         ,_param->_nb_context);
+  ALLOC1_SC_SIGNAL(out_EVENT_ACK                      ,"out_EVENT_ACK                      ",Tcontrol_t         ,_param->_nb_context);
   ALLOC1_SC_SIGNAL( in_EVENT_TYPE                     ," in_EVENT_TYPE                     ",Tevent_type_t      ,_param->_nb_context);
   ALLOC1_SC_SIGNAL( in_EVENT_DEPTH                    ," in_EVENT_DEPTH                    ",Tdepth_t           ,_param->_nb_context);
@@ -230,5 +231,6 @@
   INSTANCE1_SC_SIGNAL(_Update_Prediction_Table,out_UPDATE_RAS_INDEX               ,_param->_nb_inst_update);
   INSTANCE1_SC_SIGNAL(_Update_Prediction_Table,out_UPDATE_RAS_PREDICTION_IFETCH   ,_param->_nb_inst_update);
-  INSTANCE1_SC_SIGNAL(_Update_Prediction_Table, in_EVENT_STATE                    ,_param->_nb_context);
+  INSTANCE1_SC_SIGNAL(_Update_Prediction_Table, in_EVENT_VAL                      ,_param->_nb_context);
+  INSTANCE1_SC_SIGNAL(_Update_Prediction_Table,out_EVENT_ACK                      ,_param->_nb_context);
   INSTANCE1_SC_SIGNAL(_Update_Prediction_Table, in_EVENT_TYPE                     ,_param->_nb_context);
   if (_param->_have_port_depth)
@@ -316,8 +318,6 @@
         in_UPDATE_ACK          [i]->write(0);
       for (uint32_t i=0; i<_param->_nb_context; ++i)
-        {
-        in_EVENT_STATE [i]->write(EVENT_STATE_NO_EVENT);
-        in_EVENT_TYPE  [i]->write(EVENT_TYPE_NONE     );
-        }
+        in_EVENT_VAL   [i]->write(0);
+
       //---------------------------------------------------------------------
       //---------------------------------------------------------------------
@@ -932,9 +932,9 @@
          
           SC_START(1);
-          in_EVENT_STATE [context]->write(EVENT_STATE_END            );
+          in_EVENT_VAL   [context]->write(1);
           in_EVENT_TYPE  [context]->write(EVENT_TYPE_MISS_SPECULATION);
 
           SC_START(1);
-          in_EVENT_STATE [context]->write(EVENT_STATE_NO_EVENT       );
+          in_EVENT_VAL   [context]->write(0);
           in_EVENT_TYPE  [context]->write(EVENT_TYPE_NONE            );
         }
@@ -1366,9 +1366,9 @@
          
           SC_START(1);
-          in_EVENT_STATE [context]->write(EVENT_STATE_END            );
+          in_EVENT_VAL   [context]->write(1);
           in_EVENT_TYPE  [context]->write(EVENT_TYPE_MISS_SPECULATION);
 
           SC_START(1);
-          in_EVENT_STATE [context]->write(EVENT_STATE_NO_EVENT       );
+          in_EVENT_VAL   [context]->write(0);
           in_EVENT_TYPE  [context]->write(EVENT_TYPE_NONE            );
         }
@@ -1974,9 +1974,9 @@
             
             SC_START(1);
-            in_EVENT_STATE [context]->write(EVENT_STATE_END            );
+            in_EVENT_VAL   [context]->write(1);
             in_EVENT_TYPE  [context]->write(EVENT_TYPE_MISS_SPECULATION);
             
             SC_START(1);
-            in_EVENT_STATE [context]->write(EVENT_STATE_NO_EVENT       );
+            in_EVENT_VAL   [context]->write(0);
             in_EVENT_TYPE  [context]->write(EVENT_TYPE_NONE            );
           }
@@ -2155,5 +2155,6 @@
   delete [] out_UPDATE_RAS_PREDICTION_IFETCH;
 
-  DELETE1_SC_SIGNAL( in_EVENT_STATE                    ,_param->_nb_context);
+  DELETE1_SC_SIGNAL( in_EVENT_VAL                      ,_param->_nb_context);
+  DELETE1_SC_SIGNAL(out_EVENT_ACK                      ,_param->_nb_context);
   DELETE1_SC_SIGNAL( in_EVENT_TYPE                     ,_param->_nb_context);
   DELETE1_SC_SIGNAL( in_EVENT_DEPTH                    ,_param->_nb_context);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h	(revision 97)
@@ -52,10 +52,9 @@
   public    : Stat                           * _stat;
 
-  private   : counter_t                     ** _stat_nb_branch_hit       ; //[nb_context]
-  private   : counter_t                     ** _stat_nb_branch_miss      ; //[nb_context]
-  private   : counter_t                     ** _stat_nb_branch_unused    ; //[nb_context]
-  private   : counter_t                     ** _stat_queue_nb_cycle_empty; //[nb_context]
-  private   : counter_t                     ** _stat_queue_nb_cycle_full ; //[nb_context]
-  private   : counter_t                     ** _stat_queue_nb_elt        ; //[nb_context]
+  private   : counter_t                    *** _stat_nb_branch_hit            ; //[nb_context][MAX_BRANCH_CONDITION]
+  private   : counter_t                    *** _stat_nb_branch_miss           ; //[nb_context][MAX_BRANCH_CONDITION]
+  private   : counter_t                     ** _stat_nb_branch_unused         ; //[nb_context]
+  private   : counter_t                     ** _stat_ufpt_queue_nb_elt        ; //[nb_context]
+  private   : counter_t                     ** _stat_upt_queue_nb_elt         ; //[nb_context]
 
 #endif
@@ -143,5 +142,6 @@
 
     // ~~~~~[ Interface : "event" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-  public    : SC_IN (Tevent_state_t     )  **  in_EVENT_STATE                    ; //[nb_context]
+  public    : SC_IN (Tcontrol_t         )  **  in_EVENT_VAL                      ; //[nb_context]
+  public    : SC_OUT(Tcontrol_t         )  ** out_EVENT_ACK                      ; //[nb_context]
   public    : SC_IN (Tevent_type_t      )  **  in_EVENT_TYPE                     ; //[nb_context]
   public    : SC_IN (Tdepth_t           )  **  in_EVENT_DEPTH                    ; //[nb_context]
@@ -197,4 +197,5 @@
   private   : Tdepth_t                      * internal_UPDATE_DEPTH                   ; //[nb_inst_update]
   private   : bool                          * internal_UPDATE_RAS                     ; //[nb_inst_update]
+  private   : Tcontrol_t                    * internal_EVENT_ACK                      ; //[nb_context]
 
 #endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table.cpp	(revision 97)
@@ -76,5 +76,5 @@
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
-
+        // Constant
 	for (uint32_t i=0; i<_param->_nb_inst_branch_complete; i++)
 	  {
@@ -82,4 +82,9 @@
 	    PORT_WRITE(out_BRANCH_COMPLETE_ACK [i], internal_BRANCH_COMPLETE_ACK [i]);
 	  }
+        for (uint32_t i=0; i<_param->_nb_context; ++i)
+          {
+            internal_EVENT_ACK [i] = 1;
+            PORT_WRITE(out_EVENT_ACK [i], internal_EVENT_ACK [i]);
+          }
 
 	log_printf(INFO,Update_Prediction_Table,FUNCTION,"Method - transition");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_allocation.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_allocation.cpp	(revision 97)
@@ -151,5 +151,6 @@
       ALLOC1_INTERFACE("event", IN,SOUTH,"event", _param->_nb_context);
 
-      ALLOC1_SIGNAL_IN ( in_EVENT_STATE  ,"state",Tevent_state_t,_param->_size_event_state);
+      ALLOC1_VALACK_IN ( in_EVENT_VAL    ,VAL);
+      ALLOC1_VALACK_OUT(out_EVENT_ACK    ,ACK);
       ALLOC1_SIGNAL_IN ( in_EVENT_TYPE   ,"type" ,Tevent_type_t ,_param->_size_event_type );
       ALLOC1_SIGNAL_IN ( in_EVENT_DEPTH  ,"depth",Tdepth_t      ,_param->_size_depth      );
@@ -183,4 +184,5 @@
     ALLOC1(internal_UPDATE_DEPTH                    ,Tdepth_t  ,_param->_nb_inst_update);
     ALLOC1(internal_UPDATE_RAS                      ,bool      ,_param->_nb_inst_update);
+    ALLOC1(internal_EVENT_ACK                       ,Tcontrol_t,_param->_nb_context);
 
     // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_deallocation.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_deallocation.cpp	(revision 97)
@@ -111,5 +111,6 @@
 
         // ~~~~~[ Interface : "event" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-        DELETE1_SIGNAL( in_EVENT_STATE  ,_param->_nb_context,_param->_size_event_state);
+        DELETE1_SIGNAL( in_EVENT_VAL    ,_param->_nb_context,1);
+        DELETE1_SIGNAL(out_EVENT_ACK    ,_param->_nb_context,1);
         DELETE1_SIGNAL( in_EVENT_TYPE   ,_param->_nb_context,_param->_size_event_type );
         DELETE1_SIGNAL( in_EVENT_DEPTH  ,_param->_nb_context,_param->_size_depth      );
@@ -137,4 +138,5 @@
         DELETE1(internal_UPDATE_DEPTH                    ,_param->_nb_inst_update);
         DELETE1(internal_UPDATE_RAS                      ,_param->_nb_inst_update);
+        DELETE1(internal_EVENT_ACK                       ,_param->_nb_context);
         
         // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_branch_complete.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_branch_complete.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_branch_complete.cpp	(revision 97)
@@ -67,6 +67,6 @@
               if (take != 1)
                 throw ERRORMORPHEO(FUNCTION,toString("Branch_complete[%d] (condition %s) : bad direction.",i,toString(condition).c_str()));
-              if (addr_dest != addr_good)
-                throw ERRORMORPHEO(FUNCTION,toString("Branch_complete[%d] (condition %s) : bad destination address.",i,toString(condition).c_str()));
+//               if (addr_dest != addr_good)
+//                 throw ERRORMORPHEO(FUNCTION,toString("Branch_complete[%d] (condition %s) : bad destination address.",i,toString(condition).c_str()));
 #endif
 
@@ -85,6 +85,6 @@
 
 #ifdef DEBUG_TEST
-              if (addr_dest != addr_good)
-                throw ERRORMORPHEO(FUNCTION,toString("Branch_complete[%d] (condition %s) : bad destination address.",i,toString(condition).c_str()));
+//               if (addr_dest != addr_good)
+//                 throw ERRORMORPHEO(FUNCTION,toString("Branch_complete[%d] (condition %s) : bad destination address.",i,toString(condition).c_str()));
 #endif
 
@@ -103,6 +103,6 @@
 
 #ifdef DEBUG_TEST
-              if (addr_dest != addr_good)
-                throw ERRORMORPHEO(FUNCTION,toString("Branch_complete[%d] (condition %s) : bad destination address.",i,toString(condition).c_str()));
+//               if (addr_dest != addr_good)
+//                 throw ERRORMORPHEO(FUNCTION,toString("Branch_complete[%d] (condition %s) : bad destination address.",i,toString(condition).c_str()));
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_statistics_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_statistics_allocation.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_statistics_allocation.cpp	(revision 97)
@@ -8,4 +8,6 @@
 
 #include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h"
+#include "Behavioural/include/Allocation.h"
+
 
 namespace morpheo {
@@ -28,21 +30,76 @@
 		      param_statistics);
 
-//     _stat_nb_branch_hit        = new counter_t * [_param->_nb_context];
-//     _stat_nb_branch_miss       = new counter_t * [_param->_nb_context];
-//     _stat_nb_branch_unused     = new counter_t * [_param->_nb_context];
-//     _stat_queue_nb_cycle_empty = new counter_t * [_param->_nb_context];
-//     _stat_queue_nb_cycle_full  = new counter_t * [_param->_nb_context];
-//     _stat_queue_nb_elt         = new counter_t * [_param->_nb_context];
-  
-//     for (uint32_t i=0; i<_param->_nb_context; ++i)
-//       {
-//         _stat_nb_branch_hit        [i] = _stat->create_counter("nb_branch_hit_"       +toString(i),"",toString(_("Branch hit speculation (context %d)"),i));
-//         _stat_nb_branch_miss       [i] = _stat->create_counter("nb_branch_miss_"      +toString(i),"",toString(_("Branch miss speculation (context %d)"),i));
-//         _stat_nb_branch_unused     [i] = _stat->create_counter("nb_branch_unused_"    +toString(i),"",toString(_("Branch unused, because an previous branch have miss speculation (context %d)"),i));
-//         _stat_queue_nb_cycle_empty [i] = _stat->create_counter("queue_nb_cycle_empty_"+toString(i),"",toString(_("Cycle number where the Update Prediction Table is empty (context %d)"),i));
-//         _stat_queue_nb_cycle_full  [i] = _stat->create_counter("queue_nb_cycle_full_" +toString(i),"",toString(_("Cycle number where the Update Prediction Table is full (%d elements) (context %d)"),_param->_size_queue[i],i));
-//         _stat_queue_nb_elt         [i] = _stat->create_counter("queue_nb_elt_"        +toString(i),"",toString(_("Average branchement by cycle in Update Prediction Table (context %d)"),i));
-//       }
-    
+    {
+      ALLOC2(_stat_nb_branch_hit        ,counter_t *,_param->_nb_context,MAX_BRANCH_CONDITION);
+      ALLOC2(_stat_nb_branch_miss       ,counter_t *,_param->_nb_context,MAX_BRANCH_CONDITION);
+      ALLOC1(_stat_nb_branch_unused     ,counter_t *,_param->_nb_context);
+      
+      for (uint32_t i=0; i<_param->_nb_context; ++i)
+        {
+          std::string sum_miss        = "0";
+          std::string sum_branchement = "0";
+
+          for (uint32_t j=0; j<MAX_BRANCH_CONDITION; ++j)
+            if (is_branch_condition_valid(j))
+              {
+                std::string nb_miss        = "nb_branch_miss_"+toString(i)+"_"+toString(j); 
+                std::string nb_branchement = "+ nb_branch_hit_"+toString(i)+"_"+toString(j)+" nb_branch_miss_"+toString(i)+"_"+toString(j);
+                _stat_nb_branch_hit  [i][j] = _stat->create_counter("nb_branch_hit_" +toString(i)+"_"+toString(j),"",toString(_("Branch hit  speculation, branch condition : %s (context %d)"),toString(static_cast<branch_condition_t>(j)).c_str(),i));
+                _stat_nb_branch_miss [i][j] = _stat->create_counter(nb_miss,"",toString(_("Branch miss speculation, branch condition : %s (context %d)"),toString(static_cast<branch_condition_t>(j)).c_str(),i));
+
+//                 _stat->create_expr_average("average_miss_"+toString(i)+"_"+toString(j),
+//                                            "nb_branch_miss_"+toString(i)+"_"+toString(j),
+//                                            nb_branchement,
+//                                            "miss/branchement",
+//                                            toString(_("Average miss by branchement, branch condition : %s (context %d)"),toString(static_cast<branch_condition_t>(j)).c_str(),i));
+
+                _stat->create_expr_percent("percent_miss_"+toString(i)+"_"+toString(j),
+                                           nb_miss,
+                                           nb_branchement,
+                                           toString(_("Percent miss by branchement, branch condition : %s (context %d)"),toString(static_cast<branch_condition_t>(j)).c_str(),i));
+
+                sum_miss        = "+ "+nb_miss       +" "+ sum_miss;
+                sum_branchement = "+ "+nb_branchement+" "+sum_branchement;
+              }
+
+//           _stat->create_expr_average("average_miss_"+toString(i),
+//                                      sum_miss,
+//                                      sum_branchement,
+//                                      "miss/branchement",
+//                                      toString(_("Average miss by branchement (context %d)"),i));
+
+          _stat->create_expr_percent("percent_miss_"+toString(i),
+                                     sum_miss,
+                                     sum_branchement,
+                                     toString(_("Percent miss by branchement (context %d)"),i));
+          
+          _stat_nb_branch_unused [i] = _stat->create_counter("nb_branch_unused_" +toString(i),"",toString(_("Branch unused (previous speculation) (context %d)"),i));
+        }
+    }
+
+    {
+      ALLOC1(_stat_ufpt_queue_nb_elt        ,counter_t *,_param->_nb_context);
+     
+      for (uint32_t i=0; i<_param->_nb_context; ++i)
+        {
+          _stat_ufpt_queue_nb_elt         [i] = _stat->create_counter("ufpt_queue_nb_elt_"+toString(i),"",toString(_("Branchement in Update Fetch Prediction Table (context %d)"),i));
+          
+          _stat->create_expr_average_by_cycle("average_occupation_ufpt_queue_"+toString(i),"ufpt_queue_nb_elt_"+toString(i), "", toString(_("Average instruction by cycle in Update Fetch Prediction Table (context %d)"),i));
+          _stat->create_expr_percent         ("percent_occupation_ufpt_queue_"+toString(i), "average_occupation_ufpt_queue_"+toString(i), toString(_param->_size_ufpt_queue[i]), toString(_("Percent occupation of Update Fetch Prediction Table (context %d)"),i));
+        }
+    }
+
+    {
+      ALLOC1(_stat_upt_queue_nb_elt        ,counter_t *,_param->_nb_context);
+     
+      for (uint32_t i=0; i<_param->_nb_context; ++i)
+        {
+          _stat_upt_queue_nb_elt         [i] = _stat->create_counter("upt_queue_nb_elt_"+toString(i),"",toString(_("Average branchement by cycle in Update Prediction Table (context %d)"),i));
+          
+          _stat->create_expr_average_by_cycle("average_occupation_upt_queue_"+toString(i),"upt_queue_nb_elt_"+toString(i), "", toString(_("Average instruction by cycle in Update Prediction Table (context %d)"),i));
+          _stat->create_expr_percent         ("percent_occupation_upt_queue_"+toString(i), "average_occupation_upt_queue_"+toString(i), toString(_param->_size_upt_queue[i]), toString(_("Percent occupation of Update Prediction Table (context %d)"),i));
+        }
+    }
+
     log_printf(FUNC,Update_Prediction_Table,FUNCTION,"End");
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_statistics_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_statistics_deallocation.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_statistics_deallocation.cpp	(revision 97)
@@ -8,4 +8,5 @@
 
 #include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h"
+#include "Behavioural/include/Allocation.h"
 
 namespace morpheo {
@@ -27,10 +28,10 @@
     
     delete    _stat;
-//     delete [] _stat_nb_branch_hit       ;
-//     delete [] _stat_nb_branch_miss      ;
-//     delete [] _stat_nb_branch_unused    ;
-//     delete [] _stat_queue_nb_cycle_empty;
-//     delete [] _stat_queue_nb_cycle_full ;
-//     delete [] _stat_queue_nb_elt        ;
+
+    DELETE2(_stat_nb_branch_hit            ,_param->_nb_context,MAX_BRANCH_CONDITION);
+    DELETE2(_stat_nb_branch_miss           ,_param->_nb_context,MAX_BRANCH_CONDITION);
+    DELETE1(_stat_nb_branch_unused         ,_param->_nb_context);
+    DELETE1(_stat_ufpt_queue_nb_elt        ,_param->_nb_context);
+    DELETE1(_stat_upt_queue_nb_elt         ,_param->_nb_context);
     
     log_printf(FUNC,Update_Prediction_Table,FUNCTION,"End");
